using System;

namespace ZAD4
{
    class Program
    {
        static void Main(string[] args)
        {
            int n, k,s2;
            double s = 0;
            string[] prvi = Console.ReadLine().Split();
            n = int.Parse(prvi[0]);
            k = int.Parse(prvi[1]);
            string[] drugi = Console.ReadLine().Split();
            int[] niz = new int[n];
            for (int i=0;i<n;i++)
            {
                niz[i] = int.Parse(drugi[i]);
            }
            if (k == 0)
            {
                for (int i = 0; i < n; i++)
                {
                    s += niz[i];
                }
            }
            else
            {
                for (int i = 0; i < n; i++)
                {
                    s2 = 0;
                    for (int j = i; j < n; j++)
                    {
                        s += (s2 + niz[j]);
                        s2 += niz[j];
                    }
                }
            }
            s = s % (Math.Pow(10, 9) + 7);
            Console.WriteLine(s);
        }
    }
}